<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import DialogHeader from "@/modules/04_registry/components/DialogHeader.vue";
import type { QInput, QForm } from "quasar";
import type { treeTab } from "@/modules/05_placement/interface/index/Main";
import http from "@/plugins/http";
import config from "@/app.config";
import type { QTableProps } from "quasar";
import type {
  requestSendNoti,
  DataCopyOrder,
  ResponseOrganiz,
} from "@/modules/06_retirement/interface/response/Deceased";
import { useRouter, useRoute } from "vue-router";

/** Use */
const router = useRouter();
const route = useRoute();
const $q = useQuasar();
const mixin = useCounterMixin(); //เรียกฟังก์ชันกลาง
const {
  dialogRemove,
  messageError,
  showLoader,
  hideLoader,
  success,
  dialogConfirm,
} = mixin;

/** props*/
const props = defineProps({
  next: {
    type: Function,
    default: () => console.log("not function"),
  },
  previous: {
    type: Function,
    default: () => console.log("not function"),
  },
});
const profileId = ref<string>(route.params.id.toString());
const next = () => props.next();

/**ตัวแปร */
const myForm = ref<QForm | null>(null);
const filterRef = ref<QInput>();
const filter = ref<string>("");
const modal = ref<boolean>(false);
const search = ref<string>("");
const expanded = ref<string[]>([]);
const selected = ref<string>("");
const nodesTree = ref<treeTab[]>([]);
const selectedModal = ref<ResponseOrganiz[]>([]);
const filterModal = ref<string>("");
const rows = ref<DataCopyOrder[]>([]);
const editRows = ref<DataCopyOrder[]>([]);

/** คอลัมน์Modal ที่แสดง */
const visibleColumnsModal = ref<String[]>(["no", "idCard", "name", "position"]);

/** คอลัมน์Modal  */
const rowsModal = ref<ResponseOrganiz[]>([]);
const columnsModal = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    field: "no",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "idCard",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    field: "idCard",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ-นามสกุล",
    field: "name",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "position",
    align: "left",
    label: "ตำแหน่ง",
    field: "position",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);

/** selcet OPtion */
const optionSelect = ref<any>([
  { id: 1, name: "อีเมล" },
  { id: 2, name: "กล่องข้อความ" },
]);

/** คอลัมน์ที่แสดง */
const visibleColumns = ref<String[]>([
  "no",
  "idCard",
  "name",
  "position",
  "unit",
  "send",
]);

/** คอลัมน์ */
const columns = ref<QTableProps["columns"]>([
  { name: "no", align: "left", label: "ลำดับ", field: "no", sortable: true },
  {
    name: "idCard",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    field: "idCard",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ-นามสกุล",
    field: "name",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "position",
    align: "left",
    label: "ตำแหน่ง",
    field: "position",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "unit",
    align: "left",
    label: "หน่วยงาน",
    field: "unit",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "send",
    align: "left",
    label: "ช่องทางการส่งสำเนา",
    field: "send",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);

/** Hook */
onMounted(async () => {
  await getData();
});

/**
 * ดึงข้อมูล list จาก api
 * @param id id ของข้อมูล
 */
const listModal = async (id: string) => {
  showLoader();
  await http
    .get(config.API.copyOrderPersonsId(id))
    .then((res) => {
      const data = res.data.result;
      let list: ResponseOrganiz[] = [];
      data.map((r: ResponseOrganiz) => {
        list.push({
          firstName: r.firstName ?? "",
          idCard: r.idCard ?? "",
          lastName: r.lastName ?? "",
          name: r.name ?? "",
          position: r.position ?? "",
          prefixId: r.prefixId ?? "",
          profileId: r.profileId ?? "",
          unit: r.unit ?? "",
        });
      });
      rowsModal.value = list;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      hideLoader();
    });
};

/** เรียกข้อมูลจาก api */
const getData = async () => {
  showLoader();
  await http
    .get(config.API.detailByidDeceased(profileId.value))
    .then((res) => {
      const data = res.data.result;
      let list: DataCopyOrder[] = [];
      data.map((r: any) => {
        let selectCopyOrder = [];
        if (r.isSendMail) {
          selectCopyOrder.push(1);
        }
        if (r.isSendInbox) {
          selectCopyOrder.push(2);
        }

        list.push({
          id: r.id,
          personalId: r.profileId ?? "",
          name: `${r.prefix}${r.firstName} ${r.lastName}`,
          idCard: r.citizenId ?? "",
          position: r.positionName ?? "",
          unit: r.organizationName ?? "-",
          send: "",
          mutiselect: selectCopyOrder,
        });
      });
      if (editRows.value.length > 0) {
        list.map((r: DataCopyOrder) => {
          editRows.value.map((e: DataCopyOrder) => {
            if (r.personalId == e.personalId) {
              r.mutiselect = e.mutiselect;
            }
          });
        });
      }
      rows.value = list;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      hideLoader();
    });
};

/**
 *ฟังก์ชั่น Save
 */
const saveData = async () => {
  showLoader();
  const persons = selectedModal.value.map((item) => ({
    profileId: item.profileId,
  }));
  const dataToSend = { Persons: persons };
  await http
    .put(config.API.detailByidDeceased(profileId.value), dataToSend)
    .then((res) => {})
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      clickClose();
      getData();
      hideLoader();
    });
};

const resetFilter = () => {
  // reset ค่าที่ค้นหาเมื่อกดปุ่ม X ในกล่องค้นหา
  filter.value = "";
  filterRef.value!.focus();
};

/**
 * class จัดรูปแบบแสดงระหว่างข้อมูลที่แก้ไขหรือแสดงเฉยๆ
 * @param val ข้อมูล input สำหรับแก้ไขหรือไม่
 */
const getClass = (val: boolean) => {
  return {
    "full-width inputgreen cursor-pointer": val,
    "full-width cursor-pointer": !val,
  };
};

/** Close Modal */
const clickClose = async () => {
  modal.value = false;
};

/**
 * กดปุ่มเพิ่มด้านบน table
 */
const clickAdd = async () => {
  await nodeTree();
  selected.value = "";
  rowsModal.value = [];
  selectedModal.value = [];
  modal.value = true;
  if (myForm.value !== null) {
    myForm.value.reset();
  }
};

/**
 * ลบข้อมูล
 */
const clickDelete = (id: string) => {
  dialogRemove($q, () => deleteData(id));
};

/**
 *  โหลดโครงสร้าง tree
 */
const nodeTree = async () => {
  showLoader();
  await http
    .get(config.API.profileOrganizRoot)
    .then((res: any) => {
      const data = res.data.result;
      nodesTree.value = data;
      if (data.length > 0) {
        expanded.value = [data[0].id];
      }
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

// เลือกหน่วยงาน
const onSelected = async (id: string) => {
  await listModal(id);
};

/**ลบข้อมูล */
const deleteData = async (id: string) => {
  await http
    .delete(config.API.detailByidDeceased(id))
    .then((res) => {
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      await getData();
    });
};

/**
 * Save ข้อมูล
 */
const saveDataCopyOrder = async () => {
  if (myForm.value !== null) {
    myForm.value.validate().then(async (result: boolean) => {
      if (result) {
        dialogConfirm(
          $q,
          () => fetchSaveCopyOrder(),
          "ยืนยันการส่งหนังสือเวียน",
          "ต้องการยืนยันการส่งหนังสือเวียนหรือไม่"
        );
      }
    });
  }
};
//อัพเดทข้อมูลหลัง Save
const fetchSaveCopyOrder = async () => {
  let list: requestSendNoti[] = [];
  rows.value.map((r: DataCopyOrder) => {
    list.push({
      profileId: r.personalId,
      isSendMail: r.mutiselect.includes(1),
      isSendInbox: r.mutiselect.includes(2),
      isSendNotification: true,
    });
  });
  showLoader();
  await http
    .put(config.API.notiDeceased(profileId.value), { Persons: list })
    .then((res: any) => {
      success($q, "บันทึกข้อมูลสำเร็จ");
      next();
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
      getData();
    });
};
const updateData = (row: DataCopyOrder) => {
  editRows.value.push(row);
};
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    <q-btn
      icon="mdi-arrow-left"
      unelevated
      round
      dense
      flat
      color="primary"
      class="q-mr-sm"
      @click="router.push(`/deceased/${profileId}`)"
    />
    ส่งหนังสือเวียน
  </div>
  <div class="bg-white">
    <div class="q-py-md q-pl-md" style="height: 68vh; overflow-y: scroll">
      <div class="col-12 row q-py-sm items-center">
        <q-btn flat round color="primary" @click="clickAdd" icon="mdi-plus">
          <q-tooltip>เพิ่มข้อมูล</q-tooltip>
        </q-btn>
        <q-space />
        <div class="items-center" style="display: flex">
          <!-- ค้นหาข้อความใน table -->
          <q-input
            standout
            dense
            v-model="filter"
            ref="filterRef"
            outlined
            debounce="300"
            placeholder="ค้นหา"
            style="max-width: 200px"
            class="q-ml-sm"
          >
            <template v-slot:append>
              <q-icon v-if="filter == ''" name="search" />
              <q-icon
                v-if="filter !== ''"
                name="clear"
                class="cursor-pointer"
                @click="resetFilter"
              />
            </template>
          </q-input>
          <!-- แสดงคอลัมน์ใน table -->
          <q-select
            v-model="visibleColumns"
            :display-value="$q.lang.table.columns"
            multiple
            outlined
            dense
            :options="columns"
            options-dense
            option-value="name"
            map-options
            emit-value
            style="min-width: 150px"
            class="gt-xs q-ml-sm"
          />
        </div>
      </div>
      <q-form ref="myForm">
        <d-table
          :rows="rows"
          :columns="columns"
          :visible-columns="visibleColumns"
          :filter="filter"
          row-key="idCard"
        >
          <template v-slot:header="props">
            <q-tr :props="props">
              <q-th v-for="col in props.cols" :key="col.name" :props="props">
                <span class="text-weight-medium">{{ col.label }}</span>
              </q-th>
              <q-th auto-width />
            </q-tr>
          </template>
          <template v-slot:body="props">
            <q-tr :props="props" class="cursor-pointer">
              <q-td key="no" :props="props">
                {{ props.rowIndex + 1 }}
              </q-td>
              <q-td key="idCard" :props="props">
                {{ props.row.idCard }}
              </q-td>
              <q-td key="name" :props="props">
                {{ props.row.name }}
              </q-td>
              <q-td key="position" :props="props">
                {{ props.row.position }}
              </q-td>
              <q-td key="unit" :props="props">
                {{ props.row.unit }}
              </q-td>
              <q-td key="send" :props="props">
                <q-select
                  :class="getClass(true)"
                  hide-bottom-space
                  multiple
                  :outlined="true"
                  dense
                  lazy-rules
                  v-model="props.row.mutiselect"
                  :rules="[(val:any) => !!val || `${'กรุณาเลือกช่องทางการส่งสำเนา'}`,(val:any) => val.length > 0 || `${'กรุณาเลือกช่องทางการส่งสำเนา'}`]"
                  :label="`${'เลือกช่องทางการส่งสำเนา'}`"
                  emit-value
                  map-options
                  option-label="name"
                  :options="optionSelect"
                  option-value="id"
                  input-debounce="0"
                  color="primary"
                  @update:model-value="() => updateData(props.row)"
                >
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-black">
                        ไม่พบข้อมูลที่ค้นหา
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </q-td>
              <q-td auto-width>
                <q-btn
                  dense
                  size="12px"
                  flat
                  round
                  color="red"
                  @click="clickDelete(props.row.id)"
                  icon="mdi-delete"
                >
                  <q-tooltip>ลบข้อมูล</q-tooltip>
                </q-btn>
              </q-td>
            </q-tr>
          </template>
        </d-table>
      </q-form>
    </div>
    <q-separator />
    <div class="flex justify-end q-pa-sm q-gutter-sm">
      <q-btn
        dense
        unelevated
        label="ส่งหนังสือเวียน"
        color="public"
        @click="saveDataCopyOrder"
        class="q-px-md"
      >
      </q-btn>
    </div>
  </div>

  <q-dialog v-model="modal" persistent full-width>
    <q-card>
      <DialogHeader tittle="เลือกรายชื่อตามหน่วยงาน" :close="clickClose" />
      <q-separator />
      <q-card-section class="q-pa-sm bg-grey-1">
        <div class="row col-12 q-col-gutter-sm">
          <div class="col-xs-12 col-sm-5 row">
            <q-card flat bordered class="fit q-pa-sm">
              <q-scroll-area visible style="height: 70vh">
                <q-input
                  outlined
                  dense
                  v-model="search"
                  placeholder="ค้นหา"
                  class="q-mb-sm"
                >
                  <template v-slot:append>
                    <q-icon name="mdi-magnify" />
                  </template>
                </q-input>
                <q-tree
                  :nodes="nodesTree"
                  dense
                  node-key="id"
                  v-model:selected="selected"
                  v-model:expanded="expanded"
                  no-selection-unset
                  selected-color="primary"
                  @update:selected="onSelected"
                  default-expand-all
                />
              </q-scroll-area>
            </q-card>
          </div>
          <div class="col-xs-12 col-sm-7">
            <div class="col-12 row q-py-sm items-center">
              <q-space />
              <div class="items-center" style="display: flex">
                <q-input
                  standout
                  dense
                  v-model="filterModal"
                  ref="filterRef"
                  outlined
                  debounce="300"
                  placeholder="ค้นหา"
                  style="max-width: 200px"
                  class="q-ml-sm"
                >
                  <template v-slot:append>
                    <q-icon v-if="filterModal == ''" name="search" />
                    <q-icon
                      v-if="filterModal !== ''"
                      name="clear"
                      class="cursor-pointer"
                      @click="resetFilter"
                    />
                  </template>
                </q-input>

                <q-select
                  v-model="visibleColumnsModal"
                  :display-value="$q.lang.table.columns"
                  multiple
                  outlined
                  dense
                  :options="columnsModal"
                  options-dense
                  option-value="name"
                  map-options
                  emit-value
                  style="min-width: 150px"
                  class="gt-xs q-ml-sm"
                />
              </div>
            </div>
            <d-table
              :rows="rowsModal"
              :columns="columnsModal"
              :visible-columns="visibleColumnsModal"
              :filter="filterModal"
              row-key="profileId"
              selection="multiple"
              v-model:selected="selectedModal"
            >
              <template v-slot:header-selection="scope">
                <q-checkbox
                  keep-color
                  color="primary"
                  dense
                  v-model="scope.selected"
                />
              </template>

              <template v-slot:body-selection="scope">
                <!-- <q-checkbox
                    keep-color
                    color="primary"
                    dense
                    :model-value="scope.selected"
                    @update:model-value="
                      (val, evt) => {
                        Object.getOwnPropertyDescriptor(scope, 'selected').set(
                          val,
                          evt
                        );
                      }
                    "
                  /> -->
                <q-checkbox
                  keep-color
                  color="primary"
                  dense
                  v-model="scope.selected"
                />
              </template>

              <template v-slot:body-cell="props">
                <q-td :props="props">
                  <div v-if="props.col.name == 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>

                  <div v-else>
                    {{ props.value }}
                  </div>
                </q-td>
              </template>
            </d-table>
          </div>
        </div>
      </q-card-section>
      <q-separator />
      <q-card-actions align="right">
        <!-- <q-btn
            flat
            round
            color="public"
            icon="mdi-content-save-outline"
            @click="clickClose"
          >
            <q-tooltip>บันทึก</q-tooltip>
          </q-btn> -->
        <q-btn
          dense
          unelevated
          label="บันทึก"
          color="public"
          @click="saveData"
          class="q-px-md"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
